﻿Import-Module FailoverClusters

$CSVArray = @()
$Hosts=Get-ClusterNode
$CSVs = Get-ClusterSharedVolume

foreach($CSV in $CSVs){
    $CSVInfo=$CSV|Select -Property Name -ExpandProperty SharedVolumeInfo
    $OvercommitSpace=0
    $Overcommited="false"
            foreach ($Hoster in $Hosts){
                $VMs=Get-VM -ComputerName $Hoster.Name
                foreach($VM in $VMs){
                    $VHDs=Get-VMHardDiskDrive -VM $VM
                        foreach($VHD in $VHDs){
                            $Compare=$VHD.Path.Substring(0,25)
                                if($CSVInfo.FriendlyVolumeName -eq $Compare){
                                    $Harddisk=Get-VHD -ComputerName $Hoster.Name -Path $VHD.Path
                                    $OvercommitSpace = $OvercommitSpace + $Harddisk.Size
                                }
                        }
                }
            }
            if($CSVInfo.Partition.Size -le $OvercommitSpace){
                $Overcommited = "true"
            }
            $Info = New-Object PSObject -Property @{
                Name=$CSV.Name
                Path=$CSVInfo.FriendlyVolumeName
                Size=$CSVInfo.Partition.Size
                FreeSpace=$CSVInfo.Partition.FreeSpace
                UsedSpace=$CSVInfo.Partition.UsedSpace
                Overcommited=$Overcommited
                Overcommitment=$OvercommitSpace
                OvercommitedPercentage=((($OvercommitSpace/1024/1024/1024)/($CSVInfo.Partition.Size/1024/1024/1024))*100)-100
            }
            $CSVArray += $Info
}

$CSVArray|ft -auto Name,Path,@{Label="Size(GB)";Expression={"{0:N2}" -f ($_.Size/1024/1024/1024)}},@{Label="Free(GB)";Expression={"{0:N2}" -f ($_.FreeSpace/1024/1024/1024)}},@{Label="Used(GB)";Expression={"{0:N2}" -f ($_.UsedSpace/1024/1024/1024)}},Overcommited,@{Label="Effective Used(GB)";Expression={"{0:N2}" -f ($_.Overcommitment/1024/1024/1024)}},@{Label="Overcommited %";Expression={"{0:N2}" -f ($_.OvercommitedPercentage)}}